summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
authorRobby Workman <rworkman@slackware.com>2021-05-31 20:26:57 -0500
committerRobby Workman <rworkman@slackware.com>2021-06-04 22:24:49 -0500
commit911063fce40b1c6201528734de4defc11531fc09 (patch)
tree13263b3c54e7cacd40546ceac55d229f4a7a93de
parentab871495224069440a9645899b500f279195250f (diff)
downloadslackpkg-911063fce40b1c6201528734de4defc11531fc09.tar.xz
Import bash-completion file from upstream project
Thanks to Igor Murzov <igor@gplsoft.org> for the initial contribution of this file to the upstream bash-completion project, and thanks to Ville Skyttä <ville.skytta@iki.fi> and Koichi Murase <myoga.murase@gmail.com> for various changes and fixes since then. Co-authored-by: Igor Murzov <igor@gplsoft.org> Co-authored-by: Ville Skyttä <ville.skytta@iki.fi> Co-authored-by: Koichi Murase <myoga.murase@gmail.com>
-rw-r--r--files/shell-completion/slackpkg.bash113
-rwxr-xr-xslackpkg.SlackBuild4
2 files changed, 117 insertions, 0 deletions
diff --git a/files/shell-completion/slackpkg.bash b/files/shell-completion/slackpkg.bash
new file mode 100644
index 0000000..90abc8e
--- /dev/null
+++ b/files/shell-completion/slackpkg.bash
@@ -0,0 +1,113 @@
+# bash completion for slackpkg(8) -*- shell-script -*-
+# options list is based on `grep '\-.*\=.*)' /usr/sbin/slackpkg | cut -f1 -d\)`
+
+_slackpkg()
+{
+ local cur prev words cword
+ _init_completion -n = || return
+
+ local split=false
+ if [[ $cur == -?*=* ]]; then
+ prev="${cur%%?(\\)=*}"
+ cur="${cur#*=}"
+ split=true
+ fi
+
+ case "$prev" in
+ -delall | -checkmd5 | -checkgpg | -checksize | -postinst | -onoff | \
+ -download_all | -dialog | -batch | -only_new_dotnew | \
+ -use_includes | -spinning)
+ COMPREPLY=($(compgen -W 'on off' -- "$cur"))
+ return
+ ;;
+ -default_answer)
+ COMPREPLY=($(compgen -W 'yes no' -- "$cur"))
+ return
+ ;;
+ -dialog_maxargs | -mirror)
+ # argument required but no completions available
+ return
+ ;;
+ esac
+
+ $split && return
+
+ if [[ $cur == -* ]]; then
+ compopt -o nospace
+ COMPREPLY=($(compgen -W '-delall= -checkmd5= -checkgpg=
+ -checksize= -postinst= -onoff= -download_all= -dialog=
+ -dialog_maxargs= -batch= -only_new_dotnew= -use_includes=
+ -spinning= -default_answer= -mirror=' -- "$cur"))
+ return
+ fi
+
+ local confdir="/etc/slackpkg"
+ local config="$confdir/slackpkg.conf"
+
+ [[ -r $config ]] || return
+ . "$config"
+
+ local i action
+ for ((i = 1; i < ${#words[@]}; i++)); do
+ if [[ ${words[i]} != -* ]]; then
+ action="${words[i]}"
+ break
+ fi
+ done
+
+ case "$action" in
+ generate-template | search | file-search)
+ # argument required but no completions available
+ return
+ ;;
+ install-template | remove-template)
+ if [[ -e $confdir/templates ]]; then
+ COMPREPLY=($(
+ cd "$confdir/templates"
+ compgen -f -X "!*.template" -- "$cur"
+ ))
+ COMPREPLY=(${COMPREPLY[@]%.template})
+ fi
+ return
+ ;;
+ remove)
+ _filedir
+ COMPREPLY+=($(compgen -W 'a ap d e f k kde kdei l n t tcl x
+ xap xfce y' -- "$cur"))
+ COMPREPLY+=($(
+ cd /var/log/packages
+ compgen -f -- "$cur"
+ ))
+ return
+ ;;
+ install | reinstall | upgrade | blacklist | download)
+ _filedir
+ COMPREPLY+=($(compgen -W 'a ap d e f k kde kdei l n t tcl x
+ xap xfce y' -- "$cur"))
+ COMPREPLY+=($(cut -f 6 -d\ "${WORKDIR}/pkglist" 2>/dev/null |
+ command grep "^$cur"))
+ return
+ ;;
+ info)
+ COMPREPLY=($(cut -f 6 -d\ "${WORKDIR}/pkglist" 2>/dev/null |
+ command grep "^$cur"))
+ return
+ ;;
+ update)
+ # we should complete the same as the next `list` + "gpg"
+ COMPREPLY=($(compgen -W 'gpg' -- "$cur"))
+ ;&
+ *)
+ COMPREPLY+=($(compgen -W 'install reinstall upgrade remove
+ blacklist download update install-new upgrade-all
+ clean-system new-config check-updates help generate-template
+ install-template remove-template search file-search info' -- \
+ "$cur"))
+ return
+ ;;
+ esac
+
+} &&
+ complete -F _slackpkg slackpkg
+
+# ex: filetype=sh
diff --git a/slackpkg.SlackBuild b/slackpkg.SlackBuild
index f4f7553..443e96b 100755
--- a/slackpkg.SlackBuild
+++ b/slackpkg.SlackBuild
@@ -100,6 +100,10 @@ chown -R root:root $PKG/usr/man
# Compress manual pages
find $PKG/usr/man -type f -exec gzip -9 {} \;
+# Install bash-completion file
+mkdir -p $PKG/usr/share/bash-completion/completions
+cat $CWD/shell-completion/slackpkg.bash > $PKG/usr/share/bash-completion/completions/slackpkg
+
# Update version number:
sed -i "s/@VERSION@/$VERSION/g" $PKG/usr/sbin/slackpkg